'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

exports.maxima = maxima;
exports.maximaSync = maximaSync;

var _child_process = require('child_process');

var _child_process2 = _interopRequireDefault(_child_process);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _appRootPath = require('app-root-path');

var _appRootPath2 = _interopRequireDefault(_appRootPath);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function resourcesPath() {
  var appRoot = _appRootPath2.default.toString();
  return _path2.default.join(appRoot, 'resources');
}

function maxima(input) {
  var last, process;
  return _regenerator2.default.async(function maxima$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          last = input.trim()[input.trim().length - 1];


          if (![';', '$'].includes(last)) {
            input = input + ";";
          }

          process = _child_process2.default.spawn(_path2.default.join(resourcesPath(), 'maxima.sh'), ['--very-quiet', '-r', 'load("' + _path2.default.join(resourcesPath(), 'package.mac') + '")$ ' + input]);
          return _context.abrupt('return', new Promise(function (resolve) {
            process.stdout.on('data', function (data) {
              resolve(data.toString().trim());
              process.kill();
            });
          }));

        case 4:
        case 'end':
          return _context.stop();
      }
    }
  }, null, this);
}

function maximaSync(input) {
  var last = input.trim()[input.trim().length - 1];

  if (![';', '$'].includes(last)) {
    input = input + ";";
  }

  var result = _child_process2.default.spawnSync(_path2.default.join(resourcesPath(), 'maxima.sh'), ['--very-quiet', '-r', 'load("' + _path2.default.join(resourcesPath(), 'package.mac') + '")$ ' + input]);
  return result.stdout.toString().trim();
}